/*
 * @(#) metalib.h 2.1 88/07/23 
 */
/*****************************************************************************
 *									     *
 *     Copyright (c) 1986                  The Santa Cruz Operation, Inc.    *
 *									     *
 *     All rights reserved. No part of this program or publication may be    *
 *     reproduced, transmitted, transcribed, stored in a retrieval system,   *
 *     or translated into any language or computer language, in any form or  *
 *     by any means, electronic, mechanical, magnetic, optical, chemical,    *
 *     biological, or otherwise, without the prior written permission of:    *
 *									     *
 *	      The Santa Cruz Operation, Inc      (408) 425-7222	             *
 *	      500 Chestnut St, Santa Cruz, California 95060 USA              *
 *									     *
 *****************************************************************************/

/* max virtual coordinate */
#define	VIRTMAX		((1<<15) - 1)

/* max angle */
#define MAXANGLE	3600
/* marker types */
#define	MT_DOT		1
#define MT_PLUS		2
#define MT_ASTERISK	3
#define MT_CIRCLE	4
#define MT_X		5
#define MT_DIAMOND	-1

/* following are constants for text definitions */
#define TXT_NORMAL	0
#define TXT_LEFT	1
#define TXT_CENTER	2
#define TXT_RIGHT	3
#define TXT_TOP		1
#define TXT_CAP		2
#define TXT_HALF	3
#define TXT_BASE	4
#define TXT_BOTTOM	5

#define TXT_VERT	10
#define TXT_HORIZ	11

/* These were isolated to allow sharing with graph display routines. */
/* Following are ScoPro specific escapes, they appear in the metafile/stream
 * just before the element[s]. */
#define E_PROMAGIC	123	/* comment header; first byte of all comments */
#define E_TITLE		0	/* Main title follows */
#define E_SUBT		1	/* Sub-title follows */
#define E_GRID		2	/* Grid lines follow */
#define E_A_RNG		3	/* An A-range element follows */
#define E_B_RNG		4	/* An B-range element follows */
#define E_C_RNG		5	/* An C-range element follows */
#define E_D_RNG		6	/* An D-range element follows */
#define E_E_RNG		7	/* An E-range element follows */
#define E_F_RNG		8	/* An F-range element follows */
#define E_FORMF		9	/* FormFeed flag for drivers */
#define E_SETSCALE	10	/* Scale as set by Manager */
#define E_SUB_GRP	11	/* Start sub-group */
#define E_ESUB_GRP	12	/* End sub-group */
#define E_SET_VIEW	13	/* set isotropic or anisotropic */
#define	E_SET_COLOR	14	/* set color or bw */

#define	E_GF_BAR	30	/* Graph Type */
#define	E_GF_PIE	31
#define	E_GF_LINE	32
#define	E_GF_SBAR	33
#define E_GF_XY		34

/* sub-group types */
#define E_GT_BAR	20
#define E_GT_PIE	21
#define E_GT_LINE	22
#define E_GT_LEGEND	23

/* scaling type */
#define	ISOTROPIC	1
#define	ANISOTROPIC	2

/* color and bw */
#define	COLOR		1
#define	BW		2

/* structures and types for
 * graph entities.
 */
typedef		short			VIRTCOORD;
typedef		unsigned short		VIRTANG;

typedef	struct	x_y_point
{
	VIRTCOORD	p_x;
	VIRTCOORD	p_y;
}  POINT;

#define	PX(p)		(p).p_x
#define	PY(p)		(p).p_y

typedef struct 	c_attr
{
	int		c_red;
	int		c_green;
	int		c_blue;
}  COLOR_ATTR;

typedef	struct	t_attr
{
	int		t_font;
	int		t_color;
	VIRTCOORD	t_height;
	POINT		t_up_orient;
	POINT		t_base_orient;
	int		t_horiz_al;
	int		t_vert_al;
}  TEXT_ATTR;

typedef	struct	l_attr
{
	int	l_style;
	int	l_width;
	int	l_color;
}  LINE_ATTR;

typedef	struct	p_attr
{
	int	p_int_style;
	int	p_pattern;
	int	p_hatch;
	int	p_color;
	int	p_vis_flag;
}  POLY_ATTR;

typedef struct m_attr
{
	int	m_style;
	int	m_size;
	int	m_color;
}  MARK_ATTR;

extern	TEXT_ATTR	text_attr;
extern	LINE_ATTR	line_attr;
extern	POLY_ATTR	poly_attr;
extern	MARK_ATTR	mark_attr;

extern 	int		form_feed;
